/*
 * Firefly III API v2.0.14
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-04-20T05:28:29+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that.
 *
 * API version: 2.0.14
 * Contact: james@firefly-iii.org
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package firefly3

import (
	"time"
)

type PiggyBank struct {
	CreatedAt time.Time `json:"created_at,omitempty"`
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	// The ID of the asset account this piggy bank is connected to.
	AccountId string `json:"account_id"`
	// The name of the asset account this piggy bank is connected to.
	AccountName    string `json:"account_name,omitempty"`
	Name           string `json:"name"`
	CurrencyId     string `json:"currency_id,omitempty"`
	CurrencyCode   string `json:"currency_code,omitempty"`
	CurrencySymbol string `json:"currency_symbol,omitempty"`
	// Number of decimals supported by the currency
	CurrencyDecimalPlaces int32   `json:"currency_decimal_places,omitempty"`
	TargetAmount          string  `json:"target_amount"`
	Percentage            float32 `json:"percentage,omitempty"`
	CurrentAmount         string  `json:"current_amount,omitempty"`
	LeftToSave            string  `json:"left_to_save,omitempty"`
	SavePerMonth          string  `json:"save_per_month,omitempty"`
	// The date you started with this piggy bank.
	StartDate string `json:"start_date,omitempty"`
	// The date you intend to finish saving money.
	TargetDate string `json:"target_date,omitempty"`
	Order      int32  `json:"order,omitempty"`
	Active     bool   `json:"active,omitempty"`
	Notes      string `json:"notes,omitempty"`
	// The group ID of the group this object is part of. NULL if no group.
	ObjectGroupId string `json:"object_group_id,omitempty"`
	// The order of the group. At least 1, for the highest sorting.
	ObjectGroupOrder int32 `json:"object_group_order,omitempty"`
	// The name of the group. NULL if no group.
	ObjectGroupTitle string `json:"object_group_title,omitempty"`
}
